
UNIT Math2;  {* 㡨᪨ ᯫ, ⮤ , ⮤ ⮭, *}
             {*        ஥ ८ࠧ              *}

INTERFACE

  uses Crt;

  const nVect =400;  { . ࠧ୮ ஢          }
        nMatr =40;   { . ࠧ୮   }
        nFVect=1024; { . ࠧ୮ -஢    }
                     {     (⥫쭮 ⥯ 2)          }
        { !!  ⪥  㬥  ⠭ }

  type RVector   = array [0..nVect] of real;
       Matrix    = array[1..nMatr,1..nMatr] of real;
       Recipr    = function(n: integer; var H,x: RVector): integer;
       Jacob     = function(n: integer; var J: Matrix;
                            var x: RVector): integer;
       RFVector  = array [0..nFVect] of real;
       R2FVector = array [0..2*nFVect] of real;

  function Pow2(n: integer): integer;
  function S3M(tp,n:integer; an,bn: real; var xi,yi,Mi: RVector): integer;
  function S3(n:integer; x:real; var xi,yi,Mi: RVector;
              var code: integer): real;
  function Decomp(n: integer; var A: Matrix; var detA: real): integer;
  function Gauss(n: integer; var A: Matrix; var b: RVector): integer;
  function Newton(n:integer; var x: RVector; Rec: Recipr; Jac: Jacob;
                  epsP,epsH: real; var Nit: integer; NitMax: integer;
                  ParamDiv: boolean; NPrn: integer; yScr: byte): integer;
  function Four_C(sgn,m:integer; var Ra,Ia,Sn,Cn: RFVector;
                  ClcSn:boolean): integer;
  function Four_R(sgn,tp,m:integer; var a: RFVector; var Ra,Ia: R2FVector;
                   var Sn,Cn: RFVector; ClcSn:boolean): integer;
  function Errors(code: integer): string;

  { ஢  ⮢ (ᯮ 㭪ﬨ Decomp  Gauss)}
  var Iput: array[0..nVect] of integer;
      snVect, snMatr, snFVect: string;

IMPLEMENTATION

  function Pow2(n: integer): integer;
    {*             (0)             *}
    {*       頥 2^n        *}
    var i,p: integer;
    begin
      p:=1; for i:=1 to n do p:=p*2; Pow2:=p;
    end; {Pow2}

  function S3M(tp,n:integer; an,bn: real; var xi,yi,Mi: RVector): integer;
    {*                              (1)                              *}
    {*       *   楤 ᫥  ந   *         *}
    {*       *         㡨᪮ ᯫ              *         *}
    {*---------------------------------------------------------------*}
    {*   tp <=0 -  ࠭ ࢠ பᨬ樨    *}
    {*            ந                                        *}
    {*      >=1 -   ந                          *}
    {*   n > 1  - ᫮ 㧫,㬥襭   ( i=0,1,2,..n ) *}
    {*   an,bn  - 祭  (tp<=0)   (tp>=0)         *}
    {*            ந   ࢠ பᨬ樨      *}
    {* xi,yi,Mi - ᨢ 㧫, 祭 㭪樨  㧫  ᪮  *}
    {*             ந ( i=0,1,...n )                  *}
    {*---------------------------------------------------------------*}
    {*   頥 0  ଠ쭮 襭  11, ᫨ n>nVect   *}
    var h,B,L,D,u,v: RVector; i: integer;
    begin
      if n>nVect then begin S3M:=11; Exit end else S3M:=0;
      for i:=0 to n-1 do h[i]:=xi[i+1]-xi[i];
      for i:=1 to n-1 do begin
        D[i]:=1/(h[i]+h[i-1]);B[i]:=h[i-1]*D[i];L[i]:=h[i]*D[i];
        D[i]:=6*((yi[i+1]-yi[i])*B[i]
              -(yi[i]-yi[i-1])*L[i])/(h[i]*h[i-1]) end;
      if tp>=1 then begin
        u[0]:=0;v[0]:=an end
      else begin
        u[0]:=-0.5;v[0]:=3*((yi[1]-yi[0])/h[0]-an)/h[0] end;
      for i:=1 to n-1 do begin
        v[i]:=1/(2+B[i]*u[i-1]);
        u[i]:=-L[i]*v[i];v[i]:=(D[i]-B[i]*v[i-1])*v[i] end;
      if tp>=1 then Mi[n]:=bn else
        Mi[n]:=(6*(bn-(yi[n]-yi[n-1])/h[n-1])/h[n-1]-v[n-1])/(2+u[n-1]);
      for i:=n-1 downto 0 do Mi[i]:=u[i]*Mi[i+1]+v[i];
    end; {S3M}

  function S3(n:integer; x:real; var xi,yi,Mi: RVector;
              var code: integer): real;
    {*                            (2)                           *}
    {* 㭪  祭 㡨᪮ ᯫ  窥 x *}
    {*   न⠬ 㧫 xi,  祭 㭪樨  㧫 yi  *}
    {*    ந Mi, ⮢ 楤ன S3M  *}
    {*        n       - ᫮ 㧫, 㬥襭       *}
    {*        code=0  -  ଠ쭮 襭               *}
    {*        code=21 - ᫨ n>nVect                            *}
    {*        code=22 - ᫨ x  ⨬ ࢠ        *}
    {*                 (x<xi[0]  x>xi[n])                    *}
    var i: integer; h,h2,a,a3,b,b3: real;
    begin
      code:=0;
      if n>nVect then begin code:=21; Exit end;
      if (x<xi[0]) or (x>xi[n]) then
        begin code:=22; Exit; end;
      i:=0; repeat i:=i+1 until (x>=xi[i-1]) and (x<=xi[i]);
      h:=xi[i]-xi[i-1];h2:=Sqr(h)/6;a:=xi[i]-x;
      a3:=a*a*a/6;b:=x-xi[i-1];b3:=b*b*b/6;
      S3:=(Mi[i-1]*a3+Mi[i]*b3+(yi[i-1]-Mi[i-1]*h2)*a+
          (yi[i]-Mi[i]*h2)*b)/h;
     end; {S3}

  function Decomp(n: integer; var A: Matrix; var detA: real): integer;
    {*                        (3)                                *}
    {* ᫥ ࠧ   㣮 ᮬ⥫  *}
    {*         ।⢮ ᮢ ᪫祭                   *}
    {*   ( 㦨  ᫥ ।⥫ )     *}
    {*-----------------------------------------------------------*}
    {* n>1  - ࠧ୮                                 *}
    {* A    - 室   १                       *}
    {* detA - ।⥫ A, 祭 ᫥ ࠡ Decomp      *}
    {*         㫥: det|A|=Iput[n]*A[1,1]*A[2,2]*..*A[n,n] *}
    {*        (Iput -  ஢  ⮢ -         *}
    {*         쭠 ६ )                      *}
    {*-----------------------------------------------------------*}
    {* 蠥 0  ଠ쭮 襭, 31, ᫨ n>nMatr, *}
    {*      32, ᫨   ஦ (det|A|<1e-15)     *}
    label 1,2;
    var i,j,k,m: integer; t: real;
    begin
      if n>nMatr then begin Decomp:=31; Exit end;
      Decomp:=0; Iput[n]:=1;
      for k:=1 to n-1 do begin
        m:=k;
        for i:=k+1 to n do if abs(A[i,k])>abs(A[m,k]) then m:=i;
        Iput[k]:=m;if m<>k then Iput[n]:=-Iput[n];
        t:=A[m,k];A[m,k]:=A[k,k];A[k,k]:=t;
        if t=0 then goto 1;
        for i:=k+1 to n do A[i,k]:=-A[i,k]/t;
        for j:=k+1 to n do begin
          t:=A[m,j];A[m,j]:=A[k,j];A[k,j]:=t;
          if t=0 then goto 2;
          for i:=k+1 to n do A[i,j]:=A[i,j]+A[i,k]*t;
  2:    end;
  1:  end;
      t:=Iput[n];
      for i:=1 to n do t:=t*A[i,i]; detA:=t;
      if abs(t)<1e-15 then begin Decomp:=32; Exit end;
  end; {Decomp}

  function Gauss(n: integer; var A: Matrix; var b: RVector): integer;
    {*                          (4)                             *}
    {*    襭 ⥬  ࠢ ⮤      *}
    {*----------------------------------------------------------*}
    {*   n>1 - ࠧ୮                               *}
    {*   A -  ⥬, 䠪ਧ 㭪樥 Decomp   *}
    {*   b -  ࠢ ⥩ (   襭)        *}
    {*----------------------------------------------------------*}
    {*  ᯮ  ६ Iput,  樨஢  *}
    {*                    㭪樥 Decomp                       *}
    {*----------------------------------------------------------*}
    {*     蠥 0  ଠ쭮 襭  41,         *}
    {*                    ᫨ n>nMatr,                         *}
    var i,k,m,kb: integer; t: real;
    begin
      if n>nMatr then begin Gauss:=41; Exit end; Gauss:=0;
      for k:=1 to n-1 do begin
        m:=Iput[k];t:=b[m];b[m]:=b[k];b[k]:=t;
        for i:=k+1 to n do b[i]:=b[i]+A[i,k]*t;
      end;
      for kb:=1 to n-1 do begin
        k:=n-kb+1;b[k]:=b[k]/A[k,k];t:=-b[k];
        for i:=1 to n-kb do b[i]:=b[i]+A[i,k]*t;
      end;
      b[1]:=b[1]/A[1,1];
    end; {Gauss}

  function Newton(n:integer; var x: RVector; Rec: Recipr; Jac: Jacob;
                  epsP,epsH: real; var Nit: integer; NitMax: integer;
                  ParamDiv: boolean; NPrn: integer; yScr: byte): integer;
    {*                         (5)                             *}
    {*  襭 ⥬  ࠢ ⮤  ⮭  *}
    {*---------------------------------------------------------*}
    {* *  襭 ⥬  ࠢ ᯮ * *}
    {* *    㭪 Decomp  楤 Gauss;         * *}
    {*              ࠬ 㭪樨 Newton:                  *}
    {* n>1    - ᫮ ࠢ                                *}
    {* x      -   ( 砫쭮 ਡ)   *}
    {* Rec    - 㭪   離                    *}
    {* Jac    - 㭪   类                   *}
    {* epsP   - 筮  ࠢ                           *}
    {* epsH   - 筮  離                            *}
    {* Nit    - ᫮ 権, ஥ ॡ       *}
    {*          ⨦  筮                   *}
    {* NitMax - ࠭祭  ᨬ쭮 - 権    *}
    {* ParamDiv = true - ᯮ ⮤ ⮭            *}
    {*                    ࠬ஬                          *}
    {*          = false - ᯮ  ⮤ ⮭   *}
    {* NPrn > 0 - 뢮 ଠ  ⥪ 祭     *}
    {*            離  ࠢ   樨,      *}
    {*            ⠪ ⥪饥 祭 x[NPrn]               *}
    {*      < 0 - ⥫쭠 ଠ 뢮  ० *}
    {*            ப⪨  뢮 祭 x[|NPrn|]       *}
    {*            (室  ० -  [q])              *}
    {*      = 0 - ⥫쭠 ଠ  뢮       *}
    {* yScr   -   ࠭, 稭  ன 뢮 *}
    {*          ଠ                                     *}
    {*                                                         *}
    {*           *  -   x *                *}
    {*                                                         *}
    {*                 :                     *}
    {*  0 -  ଠ쭮 襭                          *}
    {*-51 -   ० ப⪨ ࢠ                  *}
    {* 51 - 뢠  㭪樨 Decomp ( ஦)     *}
    {* 52 - 離    㬥襭   㬥襭 *}
    {*      樮 ࠬ                            *}
    {* 53 - 樨 室 (Nit>NitMax  NormH>1e15)    *}
    {* 54 - 뢠   離                     *}
    {* 55 - 뢠                       *}
    label 1;
    var i: integer; st,ch: char; NormP,NormH,NormH1,t,detA: real;
        H,H1,x1: RVector; J: Matrix;
    function Norm(H: RVector): real;
      var i: integer; NH,mH: real;
      begin
        NH:=0;
        for i:=1 to n do
          begin mH:=abs(H[i]);if mH>NH then NH:=mH end;
        Norm:=NH;
      end;
    begin                        {Newton}
      Newton:=0; Nit:=0; t:=1;
      if Rec(n,H,x)<>0 then begin Newton:=54; Exit end;
      NormH:=Norm(H);
      repeat
        Nit:=Nit+1; st:=' ';
        if Jac(n,J,x)<>0 then begin Newton:=55; Exit end;
        if Decomp(n,J,detA)<>0 then begin Newton:=51; Exit end;
        Gauss(n,J,H); {  H - ࠢ   ! }
        NormP:=Norm(H);
 1:     for i:=1 to n do x1[i]:=x[i]-t*H[i];
        if Rec(n,H1,x1)<>0 then begin Newton:=54; Exit end;
        NormH1:=Norm(H1);
          {  樮 ࠬ (᫨ 室) }
          if ParamDiv and (NormH1>=NormH) then
            begin
              if t<1e-20 then begin Newton:=52; Exit end;
              t:=t/2; st:='*'; goto 1;
            end;
        x:=x1; H:=H1; NormH:=NormH1; NormP:=t*NormP;
        if t<=0.5 then t:=2*t else t:=1;
        if (Nit>NitMax) or (NormH1>1e15) then
          begin Newton:=53; Exit end;
        { 뢮 ⥫쭮 ਠ樨 }
        if (NPrn<>0) and (abs(NPrn)<=n) then
          begin
            if NPrn>0 then
              begin
                gotoXY(1,yScr);
                write('Nit=',Nit:3,' ',st,'t=',t:10,',NrmH=',NormH:10,
                      ',NrmP=',NormP:10,',x[',NPrn,']=',x[NPrn]:10);
              end
            else
              begin
                writeln('Nit=',Nit:3,' ',st,'t=',t:10,',NrmH=',NormH:10,
                      ',NrmP=',NormP:10,',x[',abs(NPrn),']=',x[abs(NPrn)]:10,
                      '  P.K');
                ch:=Readkey;
                if ch='q' then begin Newton:=-1; Exit end;
              end;
          end;
      until (NormP<epsP) and (NormH<epsH);
    end; {Newton}

  function Four_C(sgn,m:integer; var Ra,Ia,Sn,Cn: RFVector;
                  ClcSn:boolean): integer;
    {*                            (6)                                 *}
    {*                ஥ ८ࠧ                     *}
    {*            ਮ᪮ ᭮ 筮 㭪樨          *}
    {*----------------------------------------------------------------*}
    {* sgn = +1 - אַ ८ࠧ                               *}
    {*     = -1 - ⭮ ८ࠧ                             *}
    {* m - ࠬ, 騩 ᫮ 祪 n (n=2^m)                   *}
    {* Ra,Ia - ॠ쭠    ८ࠧ㥬 ᭮      *}
    {*         筮 㭪樨                                       *}
    {* Sn,Cn - ᨢ sin(pi/(2^(i-1))), cos(pi/(2^(i-1))), i=1,..,m *}
    {* ClcSn = true - ᨢ Sn  Cn   楤 Four_C  *}
    {*       = false - Sn  Cn   ᫥ ࠭          *}
    {*----------------------------------------------------------------*}
    {*        ८ࠧ -  ᨢ Ra  Ia            *}
    {* ( ମ  אַ ८ࠧ ନ  n)  *}
    {*----------------------------------------------------------------*}
    {*  蠥 0  ଠ쭮 襭  61, ᫨ 2^m>nFVect  *}
    label 1,2;
    var n,n2,i,j,k,s,s2: integer; tx,ty,ux,uy,wx,wy: real;
    function Pow2(n: integer): integer;
      var i,p: integer;
      begin
        p:=1; for i:=1 to n do p:=p*2; Pow2:=p;
      end;
    begin {Four_C}
      if Pow2(m)>nFVect then begin Four_C:=61; Exit end; Four_C:=0;
      if ClcSn then for i:=1 to m do
        begin tx:=pi/Pow2(i-1); Sn[i]:=sin(tx); Cn[i]:=cos(tx) end;
      n2:=Pow2(m-1);n:=n2*2;j:=0;
      for i:=0 to n-2 do
        begin
          if i<j then
            begin
              tx:=Ra[j];ty:=Ia[j];Ra[j]:=Ra[i];
              Ia[j]:=Ia[i];Ra[i]:=tx;Ia[i]:=ty;
            end;
          k:=n2;
  1:      if k>=j+1 then goto 2; j:=j-k; k:=Round(k/2); goto 1;
  2:      j:=j+k;
        end;
      for s:=1 to m do
        begin
          n2:=Pow2(s-1);s2:=n2*2;ux:=1;uy:=0;wx:=Cn[s];wy:=-sgn*Sn[s];
          for j:=0 to n2-1 do
            begin
              i:=j;
              while i<=n-1 do
                begin
                  k:=i+n2;
                  tx:=Ra[k]*ux-Ia[k]*uy;ty:=Ra[k]*uy+Ia[k]*ux;
                  Ra[k]:=Ra[i]-tx;Ia[k]:=Ia[i]-ty;
                  Ra[i]:=Ra[i]+tx;Ia[i]:=Ia[i]+ty;
                  i:=i+s2;
                end;
              tx:=ux*wx-uy*wy;uy:=ux*wy+uy*wx;ux:=tx;
            end;
        end;
      if sgn=1 then
        for i:=0 to n-1 do begin Ra[i]:=Ra[i]/n;Ia[i]:=Ia[i]/n end;
    end; {Four_C}

  function Four_R(sgn,tp,m:integer; var a: RFVector; var Ra,Ia: R2FVector;
                   var Sn,Cn: RFVector; ClcSn:boolean): integer;
    {*                            (7)                                  *}
    {*             -  ᨭ-८ࠧ                *}
    {*               ⢨⥫쭮 筮 㭪樨                   *}
    {*-----------------------------------------------------------------*}
    {* sgn = +1 - אַ ८ࠧ                                *}
    {*     = -1 - ⭮ ८ࠧ                              *}
    {* tp <= 0  - ᨭ-८ࠧ                                 *}
    {*    >= 1  - ᨭ-८ࠧ                               *}
    {* m - ࠬ, 騩 ᫮ 祪 n (n=2^m)                    *}
    {* a - ॠ쭠    ८ࠧ㥬 筮 㭪樨      *}
    {*     (  ᨭ ८ࠧ 室  a[0]=a[n]=0) *}
    {* Ra,Ia - ᯮ⥫ ᨢ                                 *}
    {* Sn,Cn - ᨢ sin(pi/(2^(i-1))), cos(pi/(2^(i-1))), i=1,.,m+1 *}
    {* ClcSn = true - ᨢ Sn  Cn   楤 Four_R   *}
    {*       = false - Sn  Cn   ᫥ ࠭           *}
    {*-----------------------------------------------------------------*}
    {*           ८ࠧ -  ᨢ a[0..n]           *}
    {*                ᯮ  楤                   *}
    {*              ᭮ ८ࠧ                   *}
    {*-----------------------------------------------------------------*}
    {*   蠥 0  ଠ쭮 襭  71, ᫨ 2^m>nFVect  *}
    var i,n: integer;
    function Pow2(n: integer): integer;
      var i,p: integer;
      begin
        p:=1; for i:=1 to n do p:=p*2; Pow2:=p;
      end;
    procedure Four_C(sgn,m:integer; var Sn,Cn:RFVector; ClcSn:boolean);
      label 1,2;
      var n,n2,i,j,k,s,s2: integer; tx,ty,ux,uy,wx,wy: real;
      begin {Four_C}
        if ClcSn then for i:=1 to m do
          begin
            tx:=pi/Pow2(i-1); Sn[i]:=sin(tx); Cn[i]:=cos(tx)
          end;
        n2:=Pow2(m-1);n:=n2*2;j:=0;
        for i:=0 to n-2 do
          begin
            if i<j then
              begin
                tx:=Ra[j];ty:=Ia[j];Ra[j]:=Ra[i];
                Ia[j]:=Ia[i];Ra[i]:=tx;Ia[i]:=ty;
              end;
            k:=n2;
    1:      if k>=j+1 then goto 2; j:=j-k; k:=Round(k/2); goto 1;
    2:      j:=j+k;
          end;
          for s:=1 to m do
            begin
              n2:=Pow2(s-1);s2:=n2*2;ux:=1;uy:=0;wx:=Cn[s];wy:=-sgn*Sn[s];
              for j:=0 to n2-1 do
                begin
                  i:=j;
                  while i<=n-1 do
                    begin
                      k:=i+n2;
                      tx:=Ra[k]*ux-Ia[k]*uy;ty:=Ra[k]*uy+Ia[k]*ux;
                      Ra[k]:=Ra[i]-tx;Ia[k]:=Ia[i]-ty;
                      Ra[i]:=Ra[i]+tx;Ia[i]:=Ia[i]+ty;
                      i:=i+s2;
                    end;
                  tx:=ux*wx-uy*wy;uy:=ux*wy+uy*wx;ux:=tx;
                end;
            end;
      end; {Four_C}
    begin  {FourR}
      n:=Pow2(m);
      if n>nFVect then begin Four_R:=71; Exit end; Four_R:=0;
      for i:=0 to n do
        begin Ra[i]:=a[i];Ia[i]:=0 end;
      for i:=n+1 to 2*n-1 do
        begin Ra[i]:=0;Ia[i]:=0 end;
      Ra[0]:=Ra[0]/2;Ra[n]:=Ra[n]/2;
      Four_C(sgn,m+1,Sn,Cn,ClcSn);
      for i:=0 to n do if tp<=0 then a[i]:=-sgn*Ia[i] else a[i]:=Ra[i];
      if sgn=1 then for i:=0 to n do begin a[i]:=2*a[i]/n end;
    end; {Four_R}

  function Errors(code: integer): string;
    {*    訡 頥 ᮮ饭   *}
    {* ᫨    ᯨ᪥ - 頥 '' *}
    const TxtErr: array[1..14] of string =
     ('S3M: C誮  ࠧ୮  (n>nVect=',
      'S3: C誮  ࠧ୮  (n>nVect=',
      'S3: A㬥  ⨬ ࢠ (x<xi[0]  x>xi[n]) ',
      'Decomp: C誮  ࠧ୮  (n>nMatr=',
      'Decomp: M ஦ (det|A|<1e-15)',
      'Gauss: C誮  ࠧ୮  (n>nMatr=',
      'Newton:   ० ப⪨ ࢠ ',
      'Newton: 뢠  㭪樨 Decomp ( ஦)',
      'Newton: 離    㬥襭   㬥襭 ࠬ',
      'Newton: 樨 室 (Nit>NitMax  NormH>1e15)',
      'Newton: 뢠   離',
      'Newton: 뢠   ',
      'Four_C: C誮  ࠧ୮  (2^m>nFVect=',
      'Four_R: C誮  ࠧ୮  (2^m>nFVect=');
    begin
      case code of
  11:   Errors:=TxtErr[1]+snVect+')';
  21:   Errors:=TxtErr[2]+snVect+')';
  22:   Errors:=TxtErr[3];
  31:   Errors:=TxtErr[4]+snMatr+')';
  32:   Errors:=TxtErr[5];
  41:   Errors:=TxtErr[6]+snMatr+')';
 -51:   Errors:=TxtErr[7];
  51:   Errors:=TxtErr[8];
  52:   Errors:=TxtErr[9];
  53:   Errors:=TxtErr[10];
  54:   Errors:=TxtErr[11];
  55:   Errors:=TxtErr[12];
  61:   Errors:=TxtErr[13]+snFVect+')';
  71:   Errors:=TxtErr[14]+snFVect+')';
      else
        Errors:='';
      end;
    end; {Errors}

  begin

    Str(nVect,snVect); Str(nMatr,snMatr); Str(nFVect,snFVect);

END.